Drupal.AjaxLoad = Drupal.AjaxLoad || {};

/**
 * Load JavaScript and CSS files. 
 */
Drupal.AjaxLoad.loadFiles = function (target, response) {

  // Handle scripts.

  // See if we have any settings to extend. Do this first so that behaviors
  // can access the new settings easily.
  if (response.scripts) {
    if (response.scripts.settings) {
      $.extend(Drupal.settings, response.scripts.settings);
    }

    // TODO: handle inline scripts.
    var types = ['core', 'module', 'theme'];
    for (var i in types) {
      for (var src in response.scripts[types[i]]) {
        // Load scripts.
        src = Drupal.settings.basePath + src;
        // Test if the script already exists.
        if (!$('script[@src*=' + src + ']').size()) {
          $.getScript(src, function () {
            Drupal.AjaxLoad.loadComplete(target);
          });
          Drupal.settings.ajaxViews.loadPending++;
        }
      }
    }
  }
  if (response.css) {
    // Handle stylesheets.
    var types = ['module', 'theme'];
    for (var media in response.css) {
      for (var i in types) {
        for (var src in response.css[media][types[i]]) {
          src = Drupal.settings.basePath + src;
          // Test if the stylesheet already exists.
          if (!$('style:contains(' + src + ')').size()) {
            $('<style type="text/css" media="' + media + '">@import "' + src + '";</style>').appendTo('head');
          }
        }
      }
    }
  }
};

/**
 * When all scripts have loaded, attach behaviors. 
 */
Drupal.AjaxLoad.loadComplete = function(target) {
  Drupal.settings.ajaxViews.loadPending--;
  if (Drupal.settings.ajaxViews.loadPending == 0) {
    Drupal.attachBehaviors(target);
  }
};
